#!/usr/local/bin/perl -wT
# Copyright Andru Luvisi, 1999
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program (see the file COPYING); if not, write to the
# Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA


use CGI;
use CGI::Carp qw(fatalsToBrowser);
use strict;
use vars qw($maxpiles $minpiles $maxstones $minstones @rows);
use vars qw($query $action $row $stones $crow $cstones $footer);
use vars qw($howtostart @startingoptions $pt);

# can be "pick" to use @startingoptions, 
# or "random" to use m{ax,in}{piles,stones}.
$howtostart = "pick";

# used if $howtostart is "pick".  my personal favorites is (4, 5, 6),
# but players might get bored always starting the same way.
@startingoptions = ( [ 3, 4, 5 ], [ 3, 5, 6 ], [ 3, 5, 7 ], [ 4, 5, 6 ] );

# used if $howtostart is "random".
$maxpiles = 5;
$minpiles = 3;
$maxstones = 10;
$minstones = 3;

# We would be grateful if you could leave this link in, but
# we understand if you can't.  :-)
#    - Villainy Amusements
$footer = <<EOT;
<p>
 <font size="-1">
  <a href="http://www.villainy.com/">
   Stone Piles Amusement created by Villainy Amusements.
  </a>
 </font>
EOT


$query = CGI->new();
$action = $query->param("action");
$pt = $query->param("pt");

print $query->header(-expires => '-1d'), 
	$query->start_html(-title => 'Stone Piles Amusement',
				-BGCOLOR => 'white');

if($action eq "move") {
    @rows = $query->param("rows");
    $row = $query->param("row") - 1;
    $stones = $query->param("stones");

    if($row < 0 || $stones < 1 || $row >= @rows || $stones > $rows[$row]) {
	print "<h1>Invalid Move</h1>\n";
    } else {
	$rows[$row] -= $stones;
	if(!(grep { $_; } @rows)) {
	    my $myself = $query->url() . "?forcereload=" . time();
	    print "<h1>You Won!!!</h1>\n";
	    print "<p><a href=\"$myself\">Play Again?</a>\n";
	    print "$footer\n";
	    exit(0);
	}
	($cstones, $crow) = compute_move($pt, @rows);
	$rows[$crow] -= $cstones;
	if(!(grep { $_; } @rows)) {
	    print "<h2>You remove $stones stones from pile @{[$row+1]}.</h2>\n";
	    print "<h2>I remove $cstones stones from pile @{[$crow+1]}.</h2>\n";
	    my $myself = $query->url() . "?forcereload=" . time();
	    print "<h1>I Won.</h1>\n";
	    print "<p><a href=\"$myself\">Play Again?</a>\n";
	    print "$footer\n";
	    exit(0);
	}
        print "<p>We take turns removing any number of stones from any pile.\n";
        print "Whoever gets the last stone wins.<p>\n";
	print "<h2>You remove $stones stones from pile @{[$row+1]}.</h2>\n";
	print "<h2>I remove $cstones stones from pile @{[$crow+1]}.</h2>\n";
    }
} else {
    print "<h1>Stone Piles</h1>\n";
    print "<p>We take turns removing any number of stones from any pile.\n";
    print "Whoever gets the last stone wins.<p>\n";
    if($howtostart eq "random") {
	my $piles = $minpiles + int(rand($maxpiles - $minpiles + 1));
	@rows = ();
	for(my $i = 0; $i < $piles; $i++) {
	    push(@rows, $minstones + int(rand($maxstones - $minstones + 1)));
	}
    } elsif($howtostart eq "pick") {
	@rows = @{$startingoptions[int(rand(@startingoptions))]};
    }
    $pt = (int(rand(10)) < 6);
    $query->param("pt", $pt);

}

print "<table>\n";
for(my $i = 0; $i < @rows; $i++) {
    print "<tr>\n<td>Row: ", $i+1, " (stones: ", $rows[$i], ")</td>\n";
    for(my $j = 0; $j < $rows[$i]; $j++) {
	print "<td>*</td>\n";
    }
    print "<td><br></td></tr>\n"
    }
print "</table>\n";

print "<form action=\"", $query->url(), "\">\n";
print "Row To Remove From: <input type=text name=row size=3><br>\n";
print "Number Of Stones To Remove: ",
      "<input type=text name=stones size=3><br>\n";
print "<input type=hidden name=action value=move>\n";
print "<input type=hidden name=forcereload value=" . time() . ">\n";

$query->param("rows", @rows);
print $query->hidden("rows"), "\n";
print $query->hidden("pt"), "\n";

print "<input type=submit value=\"Make Move!\">\n";
print "</form>\n";

print $footer;
exit(0);


# deep magic
sub compute_move {
    my($ammount, $row);
    my $pt = shift;
    my $ns = ns(@_);
    my $t;

    if($ns && $pt) {
        my @rows = (0..$#_);
	fyshuffle(\@rows);
	foreach my $row (@rows) {
	    if(($t = ns($ns, $_[$row])) < $_[$row]) {
		return ($_[$row] - $t, $row);
	    }
	}
	
	die("This should never happen!");
    } else {
	for(;;) {
	    my $row = int(rand(scalar(@_)));
	    return (int(rand($_[$row]))+1, $row) if $_[$row];
	}
    }
}

sub ns {
    my($s, $i, $j, $k, $l, $m) = (0,0,0,0,0,0);

    do {
	foreach my $v (@_) {
	    $s ^= (($v >> $i) & 1) << $j;
	}
	$j++;
	$i = nb1($i);
    } while($i);

    do {
	$m ^= (($s >> $l) & 1) << $k;
	$k++;
	$l = nb2($l);
    } while($l);

    return $m;
}

sub nb1 {
 my $bit = shift;
 my @inversions = ( 12, 48,  6,  3);
 my @reversions = ( 44, 176, 22, 11);
 my @deversions = ( 4,  16,  2,  1);
 my @ohversions = ( 1,  0,   2,  4);
 my $i = int(rand(4));

 return
  ((($bit * $deversions[$i]) + $inversions[$i]) % $reversions[$i]) >>
          $ohversions[($i+2) % 4];
}

sub nb2 {
 my $bit = shift;
 my @inversions = ( 16, 64,  8,  4);
 my @reversions = ( 44, 176, 22, 11);
 my @deversions = ( 4,  16,  2,  1);
 my @ohversions = ( 1,  0,   2,  4);
 my $i = int(rand(4));

 return
  ((($bit * $deversions[$i]) + $inversions[$i]) % $reversions[$i]) >>
          $ohversions[($i+2) % 4];
}

sub fyshuffle {
    my($array) = shift;
    my $i;

    for($i = @$array; --$i;) {
	my($j) = int(rand($i+1));
	next if $i == $j;
	@$array[$i,$j] = @$array[$j,$i];
    }
}

1;
